<?php

class Nuveomedia extends Module
{

	function __construct()
	{
		$this->name = 'nuveomedia';
		$this->tab = 'Tools';
		$this->version = '0.1';
		
		parent::__construct();
		
		$this->displayName = $this->l('<strong>NUVEO</strong>MEDIA');
		$this->description = $this->l('Add a personalized banner to your homepage');
	}

	function install()
	{
		
		if (!parent::install() OR !$this->registerHook('orderConfirmation') OR !$this->registerHook('home'))
			return false;
		return true;
	}

	function putContent($xml_data, $key, $field, $forbidden, $section)
	{
		foreach ($forbidden AS $line)
			if ($key == $line)
				return 0;
		if (!preg_match('/^'.$section.'_/i', $key))
			return 0;
		$key = preg_replace('/^'.$section.'_/i', '', $key);
		$field = htmlspecialchars($field);
		if (!$field)
			return 0;
		return ("\n".'		<'.$key.'>'.$field.'</'.$key.'>');
	}

	function getContent()
	{
		/* display the module name */
		$this->_html = '<h2>'.$this->displayName.'</h2>';
		$errors = '';

		/* update the editorial xml */
		if (isset($_POST['submitUpdate']))
		{
			// Forbidden key
			$forbidden = array('submitUpdate');
			
			foreach ($_POST AS $key => $value)
						
				if (!Validate::isCleanHtml($_POST[$key]))
				{
					$this->_html .= $this->displayError($this->l('Invalid html field, javascript is forbidden'));
					$this->_displayForm();
					return $this->_html;
				}

			// Generate new XML data
			$newXml = '<?xml version=\'1.0\' encoding=\'utf-8\' ?>'."\n";
			$newXml .= '<nuveomedia>'."\n";
			$newXml .= '	<header>';
			// Making header data
			foreach ($_POST AS $key => $field)
				if ($line = $this->putContent($newXml, $key, $field, $forbidden, 'header'))
					$newXml .= $line;
			$newXml .= "\n".'	</header>'."\n";
			$newXml .= '	<body>';
			// Making body data
			foreach ($_POST AS $key => $field)
				if ($line = $this->putContent($newXml, $key, $field, $forbidden, 'body'))
					$newXml .= $line;
			$newXml .= "\n".'	</body>'."\n";
			$newXml .= '</nuveomedia>'."\n";

			
			/* write it into the editorial xml file */
			
			if ($fd = @fopen(dirname(__FILE__).'/nuveomedia.xml', 'w'))
			{
				if (!@fwrite($fd, $newXml))
					$errors .= $this->displayError($this->l('Unable to write to the editor file.'));
				if (!@fclose($fd))
					$errors .= $this->displayError($this->l('Can\'t close the editor file.'));
			}
			else
				$errors .= $this->displayError($this->l('Unable to update the editor file.<br />Please check the editor file\'s writing permissions.'));

			
			$this->_html .= $errors == '' ? $this->displayConfirmation('Settings updated successfully') : $errors;
			
		}

		/* display the editorial's form */
		$this->_displayForm();
	
		return $this->_html;
	}

	private function _displayForm()
	{
		global $cookie;
		/* Languages preliminaries */
		$defaultLanguage = intval(Configuration::get('PS_LANG_DEFAULT'));
		$languages = Language::getLanguages();
		$iso = Language::getIsoById($defaultLanguage);
		$divLangName = 'u¤si¤height¤width';

		/* xml loading */
		$xml = false;
		if (file_exists(dirname(__FILE__).'/nuveomedia.xml'))
				if (!$xml = simplexml_load_file(dirname(__FILE__).'/nuveomedia.xml'))
					$this->_html .= $this->displayError($this->l('Your editor file is empty.'));

		$this->_html .= '
		<script type="text/javascript">id_language = Number('.$defaultLanguage.');</script>
		<form method="post" action="'.$_SERVER['REQUEST_URI'].'" >
			<fieldset style="width: 900px;">
				<legend><img src="'.$this->_path.'logo.gif" alt="" title="" /> '.$this->displayName.'</legend>
				
				<p>'.$this->l('This module will allow you to add on your homepage a banner which will display a personalised content to your competitor visitor. Give them one more reason to buy on your website and not at your competitor website.').'</p><br/>
				<label>'.$this->l('User id').'</label>
				<div class="margin-form">';

				foreach ($languages as $language)
				{
					$this->_html .= '
					<div id="u_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
							<input type="text" name="body_nuveomedia_u_'.$language['id_lang'].'" id="body_nuveomedia_u_'.$language['id_lang'].'" size="34" value="'.($xml ? stripslashes(htmlspecialchars($xml->body->{'nuveomedia_u_'.$language['id_lang']})) : '').'" />
					</div>';
				 }
				
				$this->_html .= $this->displayFlags($languages, $defaultLanguage, $divLangName, 'u', true);
				
				$this->_html .= '
					<p class="clear">'.$this->l('Id of your account define in nuveomedia control panel, nuveomedia_u').'</p>
				</div>
				<label>'.$this->l('Site id').'</label>
				<div class="margin-form">';

				foreach ($languages as $language)
				{
					$this->_html .= '
					<div id="si_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
						<input type="text" name="body_nuveomedia_si_'.$language['id_lang'].'" id="body_nuveomedia_si_'.$language['id_lang'].'" size="34" value="'.($xml ? stripslashes(htmlspecialchars($xml->body->{'nuveomedia_si_'.$language['id_lang']})) : '').'" />
					</div>';
				 }
				
				$this->_html .= $this->displayFlags($languages, $defaultLanguage, $divLangName, 'si', true);
				
				$this->_html .= '
					<p class="clear">'.$this->l('Id of your website define in nuveomedia control panel, nuveomedia_si').'</p>
				</div>
							<label>'.$this->l('Height').'</label>
				<div class="margin-form">';

				foreach ($languages as $language)
				{
					$this->_html .= '
					<div id="height_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
						<input type="text" name="body_nuveomedia_height_'.$language['id_lang'].'" id="body_nuveomedia_height_'.$language['id_lang'].'" size="34" value="'.($xml ? stripslashes(htmlspecialchars($xml->body->{'nuveomedia_height_'.$language['id_lang']})) : '').'" />
					</div>';
				 }
				
				$this->_html .= $this->displayFlags($languages, $defaultLanguage, $divLangName, 'height', true);
				
				$this->_html .= '
					<p class="clear">'.$this->l('Height per default of your add').'</p>
				</div>
							<label>'.$this->l('Width').'</label>
				<div class="margin-form">';

				foreach ($languages as $language)
				{
					$this->_html .= '
					<div id="width_'.$language['id_lang'].'" style="display: '.($language['id_lang'] == $defaultLanguage ? 'block' : 'none').';float: left;">
							<input type="text" name="body_nuveomedia_width_'.$language['id_lang'].'" id="body_nuveomedia_width_'.$language['id_lang'].'" size="34" value="'.($xml ? stripslashes(htmlspecialchars($xml->body->{'nuveomedia_width_'.$language['id_lang']})) : '').'" />
					</div>';
				 }
				
				$this->_html .= $this->displayFlags($languages, $defaultLanguage, $divLangName, 'width', true);
				
				$this->_html .= '
					<p class="clear">'.$this->l('Width per default of your add').'</p>
				</div>
				<div class="clear pspace"></div>
				<div class="margin-form clear"><input type="submit" name="submitUpdate" value="'.$this->l('Update').'" class="button" /></div>
			</fieldset>
		</form>';
		
			
		$this->_html .= "<fieldset style=\"width: 900px; margin-top:10px;\">
				<legend>Démonstration</legend>
        <p class=\"clear\">Basé sur l'historique de navigation de vos visiteurs, notre solution calcule pour vous en temps réel le contenu le plus pertinent a afficher.</p>

		<h3>Etape 1 : Un affichage par défaut vous est proposé</h3>
		<p class=\"clear\">Si vous voyez une bannière NuveoMedia, celà signifie que vous n'avez pas visité la page de notre partenaire que nous avons spécifié.</p>
    	<h3>Etape 2 : Visitez l’un de nos partenaires</h3>
		<p class=\"clear\">Visitez l'un de nos partenaires par exemple <a href=\"http://www.euro-change.fr/vendre.php\" title=\"Vendre d'occasion\" style=\"color:#268ccd;\" >EuroChange</a> et naviguer sur ce site quelque instant.</p>
        <h3>Etape 3 : Rafraîchissez cette page</h3>
		<p class=\"clear\">Vous devriez maintenant visualiser l’affichage d’un contenu optimisé en relation avec le site que vous venez de visiter.</p>
		<br/>
        <p>        <!-- Script d'insertion -->
        <script type=\"text/javascript\"> nuveomedia_u = \"51\"; nuveomedia_si = \"9\"; nuveomedia_width = 610; nuveomedia_height = 90;</script><script type=\"text/javascript\" src=\"http://www.nuveomedia.com/services/script.js\"></script><div id=\"nuveomedia\"><a href=\"http://www.nuveomedia.com\" title=\"NuveoMedia\">NuveoMedia</a> spécialiste en marketing web.</div>
        <!-- End script d'insertion --></p></fieldset>";
		
	
		
	}

	function hookHome($params)
	{
		if (file_exists('modules/nuveomedia/nuveomedia.xml'))
		{
			if ($xml = simplexml_load_file('modules/nuveomedia/nuveomedia.xml'))
			{
				global $cookie, $smarty;
				$smarty->assign(array(
					'xml' => $xml,
					'nuveomedia_u' => 'nuveomedia_u_'.$cookie->id_lang,
					'nuveomedia_si' => 'nuveomedia_si_'.$cookie->id_lang,
					'nuveomedia_width' => 'nuveomedia_width_'.$cookie->id_lang,
					'nuveomedia_height' => 'nuveomedia_height_'.$cookie->id_lang,
					'this_path' => $this->_path
				));
				return $this->display(__FILE__, 'nuveomedia.tpl');
			}
		}
		return false;
	}
	
	public function hookOrderConfirmation($params)
	{
	
	if (file_exists('modules/nuveomedia/nuveomedia.xml'))
		{
			if ($xml = simplexml_load_file('modules/nuveomedia/nuveomedia.xml'))
			{

				global $cookie, $smarty;
		
				$smarty->assign(array(
					'xml' => $xml,
					'nuveomedia_u' => 'nuveomedia_u_'.$cookie->id_lang,
					'nuveomedia_si' => 'nuveomedia_si_'.$cookie->id_lang,
					'this_path' => $this->_path
					));
				return $this->display(__FILE__, 'payment.tpl');
				
			}
		}
		return false;

	}

}
